<template>
  <tasks-view :title="workspace.name" :color="workspace.color" :icon="workspace.icon" :showOptions="!workspace.isInbox">
    <template v-slot:modal>
      <div class="py-2">
        <div
          @click="$router.push({ name: 'EditWorkspace', params: { workspace: workspace.id } })"
          class="py-2 px-4 hover:bg-gray-100"
        >
          <i class="hero pencil outline mr-2 text-gray-500"></i>
          Edit Workspace
        </div>
      </div>
    </template>
    <template v-slot:tasks>
      <div v-if="query.apply('do').getSync().length == 0 && !isNewTaskOpen">
        <div v-if="query.getSync().length == 0" class="flex flex-col items-center p-8 text-center">
          <img :src="BlankCanvas" alt="" style="height: 20rem" class="pt-16 px-8" />
          <div class="mt-8 font-bold">Welcome to your new Workspace!</div>
          <div class="mt-2 text-gray-700 text-sm">Write down what you need to do.</div>
          <div @click="createClick()" class="mt-4 button"><i class="hero solid plus mr-2"></i> Add Task</div>
        </div>
        <div v-else class="flex flex-col items-center p-16">
          <img :src="Relaxation" alt="" style="height: 20rem" />
          <div class="mt-8 font-bold">Everything done!</div>
          <div class="mt-2 text-gray-700 text-sm">What about taking a break now?</div>
          <div @click="createClick()" class="mt-4 button"><i class="hero solid plus mr-2"></i> Add Task</div>
        </div>
      </div>
      <tasks-list :thin="responsive.isMobile" class="mt-1" :tasks="query.apply('do').getSync()" sort="status" />
      <tasks-item
        v-if="isNewTaskOpen"
        class="mt-1"
        focus
        :thin="responsive.isMobile"
        :task="newTask"
        ref="newTaskRef"
        @title-enter="saveNewTask()"
        @saved="resetNewTask()"
        @closed="resetNewTask()"
      />
    </template>
  </tasks-view>
  <div
    v-if="query.apply('do').getSync().length > 0"
    @click="createClick()"
    class="mt-4 button fixed bottom-0 right-0 z-10 m-8"
  >
    <i class="hero solid plus mr-2 text-base"></i> Add Task
  </div>
</template>

<script lang="ts">
import TasksList from "@/components/Tasks/List.vue";
import TasksItem from "@/components/Tasks/Item.vue";
import Workspace from "@/models/Workspace";
import Task from "@/models/Task";
import { computed, reactive, ref } from "vue";
import { currentTaskId, openTask, openView } from "@/use/navigation";
import { inlined, useModals } from "@/use/modal";
import responsive from "@/use/responsive";
import TasksView from "../Tasks/TasksView.vue";
import BlankCanvas from "@/assets/img/undraw_blank_canvas.svg";
import Relaxation from "@/assets/img/undraw_relaxation.svg";

export default {
  components: {
    TasksItem,
    TasksList,
    TasksView
  },
  props: {
    workspace: {
      type: Workspace,
      required: true
    }
  },
  setup(props) {
    const modals = useModals({ Options: inlined() });
    const newTaskRef = ref<HTMLElement | null>(null);

    const generateNewTask = () => props.workspace.tasks().make({ id: "new" });
    const newTasks = reactive(new Map<string, Task>());
    const newTask = computed({
      get: () => {
        if (!newTasks.has(props.workspace.id!)) {
          newTasks.set(props.workspace.id!, generateNewTask());
        }
        return newTasks.get(props.workspace.id!)!;
      },
      set: (value: Task) => newTasks.set(props.workspace.id!, value)
    });
    const resetNewTask = () => {
      newTask.value = generateNewTask();
    };
    const saveNewTask = async () => {
      const saving = newTask.value?.save();
      resetNewTask();
      await saving;
    };

    const query = computed(() => props.workspace.tasks().query());

    return {
      modals,
      openView,
      isNewTaskOpen: computed(() => currentTaskId.value == "new"),
      newTask,
      saveNewTask,
      resetNewTask,
      newTaskRef,
      query,
      createClick: () => {
        openTask("new");
        newTaskRef.value?.scrollIntoView();
      },
      responsive,
      BlankCanvas,
      Relaxation
    };
  }
};
</script>
